package org.zengsource.util;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public abstract class JSONUtil {

	/** {id:04600,x:625.5,y:206,w:264,h:312} */
	public static Map<String, Object> parseObject(String jsonObj) {
		if (StringUtil.isBlank(jsonObj) //
				|| !jsonObj.startsWith("{") //
				|| !jsonObj.endsWith("}") //
				|| "{}".equals(jsonObj)) {
			return null;
		}
		Map<String, Object> map = new HashMap<String, Object>();
		String data = jsonObj.substring(1, jsonObj.length() - 1);
		String[] properties = data.split(",");
		for (String property : properties) {
			String[] pair = property.split(":");
			map.put(pair[0], pair[1]);
		}
		return map;
	}

	/**
	 * [{id:20090121133930169,x:725.5,y:286,w:60,h:37},{id:20090121133930169,x:
	 * 725.5,y:286,w:60,h:37}]
	 */
	public static List<Map<String, Object>> parseArray(String jsonArray) {
		if (StringUtil.isBlank(jsonArray) //
				|| !jsonArray.startsWith("[") //
				|| !jsonArray.endsWith("]") //
				|| "[]".equals(jsonArray)) {
			return null;
		}
		String data = jsonArray.substring(1, jsonArray.length() - 1);
		String[] objs = data.split("\\},\\{");
		List<Map<String, Object>> list = new ArrayList<Map<String, Object>>();
		for (String obj : objs) {
			String jsonObj = obj;
			if (!obj.startsWith("{")) {
				jsonObj = "{" + jsonObj;
			}
			if (!obj.endsWith("}")) {
				jsonObj = jsonObj + "}";
			}
			list.add(parseObject(jsonObj));
		}
		return list;
	}

}
