/**
 * 
 */
package org.zengsource.util;

/**
 * @author snzeng
 * 
 */
public abstract class NumberUtil {


	public static Integer str2Int(String str, Integer def) {
		return NumberUtil.string2Integer(str, def);
	}

	public static Integer string2Integer(String str, Integer def) {
		if (str == null) {
			return def;
		}
		try {
			return Integer.parseInt(str);
		} catch (NumberFormatException e) {
			return def;
		}
	}

	public static float string2Float(String s, Float def) {
		try {
			return Float.parseFloat(s);
		} catch (NumberFormatException e) {
			return def;
		}
	}
	
	public static int random(int max) {
		return (int) (max * Math.random());
	}

	public static double str2Dou(String str, double def) {
		if (str == null) {
			return def;
		}
		try {
			return Double.parseDouble(str);
		} catch (NumberFormatException e) {
			return def;
		}
	}
	
	public static void main(String[] args) {
		System.out.println(NumberUtil.random(30));
	}
	
}
