/**
 * 
 */
package org.zengsource.util;

import java.util.Properties;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * @author snzeng
 * @since 6.0
 */
public abstract class PropertiesUtil {

	static final String INNER_REF_PATTERN = ".*\\$\\{(.*)\\}.*";

	public static String getValue(Properties props, String key, String def) {
		if (props == null) {
			return null;
		}
		if (key == null) {
			return null;
		}
		String value = props.getProperty(key, def);
		if (value == null) {
			return null;
		}
		Pattern pattern = Pattern.compile(INNER_REF_PATTERN);
		Matcher matcher = pattern.matcher(value);
		while (matcher.find()) {
			String exp = matcher.group(1);
			value = value.replaceAll("\\$\\{" + exp + "\\}", getValue(props, exp));
		}
		return value;
	}

	public static String getValue(Properties props, String key) {
		if (props == null) {
			return null;
		}
		if (key == null) {
			return null;
		}
		String value = props.getProperty(key);
		if (value == null) {
			return null;
		}
		Pattern pattern = Pattern.compile(INNER_REF_PATTERN);
		Matcher matcher = pattern.matcher(value);
		while (matcher.find()) {
			String exp = matcher.group(1);
			value = value.replaceAll("\\$\\{" + exp + "\\}", getValue(props, exp));
		}
		return value;
	}
	
	public static void main(String[] args) {
		
		Properties props = new Properties();
		props.put("a", "aaa");
		props.put("b", "${a}+bbb");
		System.out.println(PropertiesUtil.getValue(props, "b"));
	}

}
