/**
 * 
 */
package org.zengsource.util.spring.view;

import java.io.IOException;
import java.io.Writer;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;


import org.dom4j.Document;
import org.springframework.web.servlet.view.AbstractView;
import org.zengsource.util.StringUtil;

/**
 * @author zeng.xiaoning
 * @since 6.0
 */
public class XmlView extends AbstractView {

	// ~~~ STATIC ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //

	// ~~~ PROPERTIES ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //

	protected String xml;
	protected Document document;

	// ~~~ CONSTRUCTIONS ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
	
	public XmlView() {
		// TODO Auto-generated constructor stub
	}

	public XmlView(Document document) {
		this.document = document;
	}

	// ~~~ FUNCTIONS ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //

	@Override
	protected void renderMergedOutputModel(Map<String, Object> model, HttpServletRequest request,
			HttpServletResponse response) throws Exception {
		response.setContentType("application/xml");
		response.setCharacterEncoding("UTF-8");
		try {
			Writer writer = response.getWriter();
			if(StringUtil.isBlank(this.xml) && this.document != null) {
				this.xml = this.document.asXML();
			}
			writer.write(this.xml);
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
	}

	// ~~~ G^SETTERS ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
	
	public String getXml() {
		return xml;
	}
	
	public void setXml(String xml) {
		this.xml = xml;
	}

	public Document getDocument() {
		return document;
	}

	public void setDocument(Document document) {
		this.document = document;
	}

}
